# coding: utf-8

"""
    Platform API

    _OpenAPI specification for the **Platform API** of **Empire**, the allocation and nomination platform of BritNed_  ---  Additional documentation available in the API's [GitHub repository](https://github.com/britned/empire-platform-api) 

    The version of the OpenAPI document: 6.0.0
    Contact: britned.info@britned.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from empire_platform_api_public_client_legacy.models.webhook_event_status import WebhookEventStatus
from empire_platform_api_public_client_legacy.models.webhook_event_type import WebhookEventType

class WebhookHistoryItem(BaseModel):
    """
    WebhookHistoryItem
    """
    status: WebhookEventStatus = Field(...)
    event_type: WebhookEventType = Field(default=..., alias="eventType")
    sent_at: Optional[datetime] = Field(default=None, alias="sentAt", description="Date and time with zone information, marks an **absolute point** on the timeline  - theoretically can be sent and received with any zone offset (until it marks the desired **absolute point** on the timeline) - in practice it is advised to transfer it in UTC timezone (with Z offset, \"Zulu time\") - ISO 8601 compliant string in `yyyy-mm-ddThh:mm:ss.SSSZ` format ")
    request_headers: StrictStr = Field(default=..., alias="requestHeaders")
    request_body: StrictStr = Field(default=..., alias="requestBody")
    error_message: Optional[StrictStr] = Field(default=None, alias="errorMessage")
    response_code: Optional[StrictStr] = Field(default=None, alias="responseCode")
    response_headers: Optional[StrictStr] = Field(default=None, alias="responseHeaders")
    response_body: Optional[StrictStr] = Field(default=None, alias="responseBody")
    __properties = ["status", "eventType", "sentAt", "requestHeaders", "requestBody", "errorMessage", "responseCode", "responseHeaders", "responseBody"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> WebhookHistoryItem:
        """Create an instance of WebhookHistoryItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> WebhookHistoryItem:
        """Create an instance of WebhookHistoryItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return WebhookHistoryItem.parse_obj(obj)

        _obj = WebhookHistoryItem.parse_obj({
            "status": obj.get("status"),
            "event_type": obj.get("eventType"),
            "sent_at": obj.get("sentAt"),
            "request_headers": obj.get("requestHeaders"),
            "request_body": obj.get("requestBody"),
            "error_message": obj.get("errorMessage"),
            "response_code": obj.get("responseCode"),
            "response_headers": obj.get("responseHeaders"),
            "response_body": obj.get("responseBody")
        })
        return _obj


